//************************************************************************************
//**  
//**  File name:     E:\PIC\SHT10\SHT10_88_3_no_crc_appar.c
//**  Generated by:  Flowcode v4.5.18.74
//**  Date:          Wednesday, August 27, 2014 11:13:55
//**  Licence:       Professional
//**  Registered to: 2A1RRG
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P16F877A
#define MX_EE
#define MX_EE_TYPE2
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_C
#define MX_SPI_SDI 4
#define MX_SPI_SDO 5
#define MX_SPI_SCK 3
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_I2C
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 3
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 2
#define MX_PWM_TRIS2 trisc
#define MX_PWM_2 1

//Functions
#define MX_CLK_SPEED 10000000
#ifdef _BOOSTC
#include <system.h>
#endif
#ifdef HI_TECH_C
#include <pic.h>
#endif

//Configuration data
#ifdef _BOOSTC
#pragma DATA 0x2007, 0x3f3a
#endif
#ifdef HI_TECH_C
__CONFIG(0x3f3a);
#endif

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Macro function declarations
void FCM_LCD();
void FCM_TEMPER();
void FCM_HUMIDITY();
void FCM_READ_BUS();
void FCM_PULS_A();


//Variable declarations
#define FCSZ_T_STR 6
#define FCSZ_H_STR 5
char FCV_T_STR[FCSZ_T_STR];
char FCV_LSB_H;
char FCV_MSB_H;
short FCV_H;
float FCV_TEMP;
float FCV_T_C;
char FCV_H_STR[FCSZ_H_STR];
float FCV_RH;
char FCV_LSB_T;
char FCV_ZNAK;
char FCV_MSB_T;
short FCV_T;




//I2C_Master(0): //Defines:

/**** Macro Substitutions ****
0 = SM BUS Enable
0 = Slew Rate Enable
12 = Baud Rate
1 = Hardware or Bitbanged I2C
portc = Bitbanged Port Register
trisc = Bitbanged Data Direction Register
3 = Bitbanged Clock Pin
4 = Bitbanged Data Pin
MI2C_131848 = Unique component ID
******************************/

//common defines
#define MI2C_131848_MX_MI2C_SMBUS  	0
#define MI2C_131848_MX_MI2C_SLEW  	0
#define MI2C_131848_MX_MI2C_BAUD 	(12/2)
#define MI2C_131848_MX_HARDWARE  	1

#if MI2C_131848_MX_HARDWARE == 1
  #ifdef MX_I2C_A
    #define MI2C_131848_MX_TRIS trisa
    #define MI2C_131848_MX_PORT porta
  #endif
  #ifdef MX_I2C_B
    #define MI2C_131848_MX_TRIS trisb
    #define MI2C_131848_MX_PORT portb
  #endif
  #ifdef MX_I2C_C
    #define MI2C_131848_MX_TRIS trisc
    #define MI2C_131848_MX_PORT portc
  #endif
  #ifdef MX_I2C_D
    #define MI2C_131848_MX_TRIS trisd
    #define MI2C_131848_MX_PORT portd
  #endif
  #define MI2C_131848_MX_SCL MX_I2C_SCL
  #define MI2C_131848_MX_SDA MX_I2C_SDA
#else
  #define MI2C_131848_MX_PORT    portc
  #define MI2C_131848_MX_TRIS    trisc
  #define MI2C_131848_MX_SCL     3
  #define MI2C_131848_MX_SDA     4
#endif

#define MI2C_131848_MX_I2C_DELAY 	delay_us(5);
#define MI2C_131848_SET_SCL			set_bit(MI2C_131848_MX_TRIS,MI2C_131848_MX_SCL);
#define MI2C_131848_CLEAR_SCL		{clear_bit(MI2C_131848_MX_TRIS,MI2C_131848_MX_SCL); clear_bit(MI2C_131848_MX_PORT,MI2C_131848_MX_SCL);}
#define MI2C_131848_SET_SDA			set_bit(MI2C_131848_MX_TRIS,MI2C_131848_MX_SDA);
#define MI2C_131848_CLEAR_SDA		{clear_bit(MI2C_131848_MX_TRIS,MI2C_131848_MX_SDA); clear_bit(MI2C_131848_MX_PORT,MI2C_131848_MX_SDA);}




//I2C_Master(0): //Macro function declarations

void FCD_I2C_Master0_MI2C_Init();
void FCD_I2C_Master0_MI2C_Start();
void FCD_I2C_Master0_MI2C_Restart();
void FCD_I2C_Master0_MI2C_Stop();
char FCD_I2C_Master0_MI2C_Transmit_Byte(char Data);
char FCD_I2C_Master0_MI2C_Receive_Byte(char Last);
void FCD_I2C_Master0_MI2C_Send_Byte_Transaction(char Device_ID, char AddrH, char AddrL, char Data);
char FCD_I2C_Master0_MI2C_Receive_Byte_Transaction(char Device_ID, char AddrH, char AddrL);


//LCDDisplay(0): //Defines:

/**** Macro Substitutions ****
portd = D1 Port
trisd = D1 Data Direction
portd = D2 Port
trisd = D2 Data Direction
portd = D3 Port
trisd = D3 Data Direction
portd = D4 Port
trisd = D4 Data Direction
portd = RS Port
trisd = RS Data Direction
portd = E Port
trisd = E Data Direction
4 = Data 1_Pin
5 = Data 2 Pin
6 = Data 3 Pin
7 = Data 4 Pin
2 = RS Pin
3 = Enable Pin
LCD_132012 = Unique Component Reference Number
2 = Row Count
16 = Column Count
******************************/

	//component connections
	#define LCD_132012_PORT0    portd
	#define LCD_132012_TRIS0    trisd
	#define LCD_132012_PORT1    portd
	#define LCD_132012_TRIS1    trisd
	#define LCD_132012_PORT2    portd
	#define LCD_132012_TRIS2    trisd
	#define LCD_132012_PORT3    portd
	#define LCD_132012_TRIS3    trisd
	#define LCD_132012_PORT4    portd
	#define LCD_132012_TRIS4    trisd
	#define LCD_132012_PORT5    portd
	#define LCD_132012_TRIS5    trisd
	#define LCD_132012_BIT0    	4
	#define LCD_132012_BIT1    	5
	#define LCD_132012_BIT2    	6
	#define LCD_132012_BIT3    	7
	#define LCD_132012_RS      	2
	#define LCD_132012_E       	3
	#define LCD_132012_ROWCNT	2
	#define LCD_132012_COLCNT	16

	#ifdef _BOOSTC
	  #define LCD_132012_DELAY   delay_10us(10)
	#endif
	#ifdef _C2C_
	  #define LCD_132012_DELAY   delay_us(100)
	#endif
	#ifdef HI_TECH_C
	  #define LCD_132012_DELAY   __delay_us(120)
	#endif
	#ifndef LCD_132012_DELAY
	  #define LCD_132012_DELAY   delay_us(100)
	#endif

	#define ModIDLCD_132012LCD_132012 (((trisd << 5) + portd) << 9)




//LCDDisplay(0): //Macro function declarations

void FCD_LCDDisplay0_RawSend(char in, char mask);
void FCD_LCDDisplay0_Start();
void FCD_LCDDisplay0_Clear();
void FCD_LCDDisplay0_PrintASCII(char Character);
void FCD_LCDDisplay0_Command(char in);
void FCD_LCDDisplay0_Cursor(char x, char y);
void FCD_LCDDisplay0_PrintNumber(short Number);
void FCD_LCDDisplay0_PrintString(char* String, char MSZ_String);
void FCD_LCDDisplay0_ScrollDisplay(char Direction, char Num_Positions);
void FCD_LCDDisplay0_ClearLine(char Line);
void FCD_LCDDisplay0_RAM_Write(char nIdx, char d0, char d1, char d2, char d3, char d4, char d5, char d6, char d7);



//I2C_Master(0): //Macro implementations


void FCD_I2C_Master0_MI2C_Init()
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (0 != MX_MIAC_MM_MIAC_BASE)

		unsigned int ModID = ((trisc << 5) + portc) << 9;

		MIAC_CAN_TX[0] = 0;			//SMBUS
		MIAC_CAN_TX[1] = 0;			//Slew
		MIAC_CAN_TX[2] = (12 >> 8);		//Baud_H
		MIAC_CAN_TX[3] = 12;			//Baud_L

		MIAC_Module_WR(ModID, 384, 4,1,0);
		MIAC_Module_GetAck(ModID + 32, 384, 20);
	  #endif
	#else
		#if MI2C_131848_MX_HARDWARE == 1									//Use Master I2C Hardware
			#ifndef MX_MI2C
				#error "This chip does not have Master I2C capability"
			#else
				#if MI2C_131848_MX_MI2C_SLEW == 1
					cr_bit (sspstat,SMP);					//Slew Rate Control Enabled
				#else
					st_bit (sspstat,SMP);					//Slew Rate Control Disabled
				#endif
				#if MI2C_131848_MX_MI2C_SMBUS == 1
					st_bit (sspstat,CKE);					//Enable SMBus specific inputs
				#else
					cr_bit (sspstat,CKE);					//Disable SMBus specific inputs
				#endif

				#ifdef _BOOSTC
				  #ifdef SSPCON
					sspcon = 0x28;								//Setup I2C into Master Mode
				  #endif
				  #ifdef SSPCON1
					sspcon1 = 0x28;								//Setup I2C into Master Mode
				  #endif
				#endif

				#ifdef HI_TECH_C
				  #ifdef sspcon
					sspcon = 0x28;								//Setup I2C into Master Mode
				  #endif
				  #ifdef sspcon1
					sspcon1 = 0x28;								//Setup I2C into Master Mode
				  #endif
				#endif

				sspadd = MI2C_131848_MX_MI2C_BAUD;						//Set the Baud Rate
				sspcon2 = 0x00;								//Clear the control bits
				st_bit(intcon, GIE);
				set_bit(MI2C_131848_MX_TRIS, MI2C_131848_MX_SCL);			//Configure SCL as Input
				set_bit(MI2C_131848_MX_TRIS, MI2C_131848_MX_SDA);			//Configure SDA as Input
			#endif
		#else												//Use Software
	    	clear_bit(MI2C_131848_MX_PORT,MI2C_131848_MX_SCL);						//Set Outputs to 0
			clear_bit(MI2C_131848_MX_PORT,MI2C_131848_MX_SDA);
			MI2C_131848_SET_SDA;										//Configure SDA as Input
			MI2C_131848_SET_SCL;										//Configure SCL as Input
		#endif
	#endif

}

void FCD_I2C_Master0_MI2C_Start()
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (0 != MX_MIAC_MM_MIAC_BASE)

		unsigned int ModID = ((trisc << 5) + portc) << 9;

		MIAC_Module_WR(ModID, 385, 0,1,0);
		MIAC_Module_GetAck(ModID + 32, 385, 20);
	  #endif
	#else
		#if MI2C_131848_MX_HARDWARE == 1								//Use Master I2C Hardware
			#ifndef MX_MI2C
				#error "This chip does not have Master I2C capability"
			#else
				cr_bit(pir1,SSPIF);							//Clear SSP interrupt flag
				st_bit(sspcon2,SEN);						//Initiate start condition
				while(ts_bit(sspcon2,SEN));					//Wait for start bit to be generated
			#endif
		#else												//Use Software I2C
			MI2C_131848_SET_SCL;										//Make Sure SCL is Set
			MI2C_131848_SET_SDA;										//Make Sure SDA is Set
			MI2C_131848_MX_I2C_DELAY;									//Small Delay
			MI2C_131848_CLEAR_SDA;										//Clear SDA
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_CLEAR_SCL;										//Clear SCL
			MI2C_131848_MX_I2C_DELAY;
		#endif
	#endif

}

void FCD_I2C_Master0_MI2C_Restart()
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (0 != MX_MIAC_MM_MIAC_BASE)

		unsigned int ModID = ((trisc << 5) + portc) << 9;

		MIAC_Module_WR(ModID, 386, 0,1,0);
		MIAC_Module_GetAck(ModID + 32, 386, 20);
	  #endif
	#else
		#if MI2C_131848_MX_HARDWARE == 1									//Use Master I2C Hardware
			#ifndef MX_MI2C
				#error "This chip does not have Master I2C capability"
			#else
				cr_bit(pir1,SSPIF);							//Clear SSP interrupt flag
				st_bit(sspcon2,RSEN);						//Initiate restart condition
				while(ts_bit(sspcon2,RSEN));				//Wait for restart bit to be generated
			#endif
		#else												//Use Software I2C
			MI2C_131848_SET_SDA;										//Set SDA High
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_SET_SCL;										//Set SCL High
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_CLEAR_SDA;										//Set SDA Low
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_CLEAR_SCL;										//Set SCL Low
			MI2C_131848_MX_I2C_DELAY;
		#endif
	#endif

}

void FCD_I2C_Master0_MI2C_Stop()
{
		#if MI2C_131848_MX_HARDWARE == 1									//Use Master I2C Hardware
			#ifndef MX_MI2C
				#warning "This chip does not have Master I2C capability"
			#else
				cr_bit(pir1,SSPIF);							//Clear SSP interrupt flag
				st_bit(sspcon2,PEN);						//Initiate stop condition
				while(ts_bit(sspcon2,PEN));					//Wait for stop bit to be generated
			//	delay_ms(10);								//Wait before reusing the I2C BUS
			#endif
		#else												//Use Software I2C
			MI2C_131848_CLEAR_SCL;										//Set SCL Low
			MI2C_131848_CLEAR_SDA;										//Set SDA Low
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_SET_SCL;										//Set SCL High
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_SET_SDA;										//Set SDA High
			delay_ms(10);									//Wait before reusing the I2C BUS
		#endif
}

char FCD_I2C_Master0_MI2C_Transmit_Byte(char Data)
{
		#if MI2C_131848_MX_HARDWARE == 1									//Use Master I2C Hardware
			#ifndef MX_MI2C
				#warning "This chip does not have Master I2C capability"
			#else
				cr_bit(pir1,SSPIF);							//Clear SSP interrupt flag
				sspbuf=Data;								//Send byte
				while(ts_bit(pir1,SSPIF) == 0);				//Wait for control bit to be sent
				if(ts_bit(sspcon2,ACKSTAT))					//Check Acknowledgement
					return (1);								//No Acknowledgement
				else return (0);							//Acknowledgement received
			#endif
		#else
		char in = 1;//my
		char counter = 0;//my
													//Use Software I2C
			char bit_mask;
			char local_ack = 0;
			for(bit_mask=0x80;bit_mask;bit_mask=bit_mask>>1)
			{
				if(Data & bit_mask)
				{
					MI2C_131848_SET_SDA;								//Set SDA High
				} else {
					MI2C_131848_CLEAR_SDA;								//Set SDA Low
				}
				MI2C_131848_MX_I2C_DELAY;
				MI2C_131848_SET_SCL;									//Set SCL High
				MI2C_131848_MX_I2C_DELAY;
				MI2C_131848_CLEAR_SCL;									//Set SCL Low
				MI2C_131848_MX_I2C_DELAY;
			}
			MI2C_131848_SET_SDA;										//Set SDA High
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_SET_SCL;										//Set SCL High
			MI2C_131848_MX_I2C_DELAY;
			if (test_bit(MI2C_131848_MX_PORT,MI2C_131848_MX_SDA))					//Get the Status Bit
				local_ack = 1;
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_CLEAR_SCL;										//Set SCL Low
			MI2C_131848_MX_I2C_DELAY;

	/*	while (in ==1)
		{
			in = MI2C_131848_MX_PORT.MI2C_131848_MX_SDA;
			delay_ms(4);
			counter++;
			if (counter == 0x7F)		// Security: if the conversion is not completed
				return 1;				// after > 1 sec -> break.
		}
	*/


			return (local_ack);								//0 = Ack received : 1 = Ack not received
		#endif
}

char FCD_I2C_Master0_MI2C_Receive_Byte(char Last)
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (0 != MX_MIAC_MM_MIAC_BASE)

		unsigned int ModID = ((trisc << 5) + portc) << 9;

		MIAC_CAN_TX[0] = Last;

		MIAC_Module_WR(ModID, 389, 1,1,0);
		MIAC_Module_GetAck(ModID + 32, 389, 20);
		return(MIAC_CAN_RX[0]);
	  #endif
	#else
		#if MI2C_131848_MX_HARDWARE == 1									//Use Master I2C Hardware
			#ifndef MX_MI2C
				#error "This chip does not have Master I2C capability"
			#else
				cr_bit(pir1,SSPIF);							//Clear SSP interrupt flag
				st_bit(sspcon2,RCEN);						//Initiate Read
				while(ts_bit(pir1,SSPIF) == 0);				//Wait for data read
				if (Last)
					st_bit(sspcon2,ACKDT);					//Send Nack
				else cr_bit(sspcon2,ACKDT);					//Send Ack
				st_bit(sspcon2,ACKEN);						//Initiate Nack
				while(ts_bit(sspcon2,ACKEN));				//Wait for data read
				return(sspbuf);								//Store incoming data
			#endif
		#else												//Use Software I2C
			char bit_mask;
			char Data = 0;
			char local_ack;
			MI2C_131848_SET_SDA;										//Set SDA High
			MI2C_131848_MX_I2C_DELAY;
			for(bit_mask=0x80;bit_mask;bit_mask=bit_mask>>1)
			{
				MI2C_131848_SET_SCL;									//Set SCL High
				MI2C_131848_MX_I2C_DELAY;
				MI2C_131848_SET_SDA;
				if(test_bit(MI2C_131848_MX_PORT,MI2C_131848_MX_SDA))				//Read Incoming Bit
					Data = Data | bit_mask;					//Add data to variable
				MI2C_131848_CLEAR_SCL;									//Set SCL Low
				MI2C_131848_MX_I2C_DELAY;
			}
			if (Last)										//Acknowledge?
			{
				MI2C_131848_SET_SDA;									//Send Nack
			} else {
				MI2C_131848_CLEAR_SDA;									//Send Ack
			}
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_SET_SCL;										//Set SCL High
			MI2C_131848_MX_I2C_DELAY;
			MI2C_131848_CLEAR_SCL;										//Set SCL Low
			MI2C_131848_MX_I2C_DELAY;
			return (Data);
		#endif
	#endif
}

void FCD_I2C_Master0_MI2C_Send_Byte_Transaction(char Device_ID, char AddrH, char AddrL, char Data)
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (0 != MX_MIAC_MM_MIAC_BASE)

		unsigned int ModID = ((trisc << 5) + portc) << 9;

		MIAC_CAN_TX[0] = Device_ID;
		MIAC_CAN_TX[1] = AddrH;
		MIAC_CAN_TX[2] = AddrL;
		MIAC_CAN_TX[3] = Data;

		MIAC_Module_WR(ModID, 390, 4,1,0);
		MIAC_Module_GetAck(ModID + 32, 390, 20);
	  #endif
	#else
		Device_ID = Device_ID << 1;			//Shift Device ID to enable write mode

		FCD_I2C_Master0_MI2C_Start();						//Start transaction
		FCD_I2C_Master0_MI2C_Transmit_Byte(Device_ID);		//Transmit Device Address
		FCD_I2C_Master0_MI2C_Transmit_Byte(AddrH);			//Transmit Internal Address
		FCD_I2C_Master0_MI2C_Transmit_Byte(AddrL);
		FCD_I2C_Master0_MI2C_Transmit_Byte(Data);			//Send Data byte
		FCD_I2C_Master0_MI2C_Stop();						//Stop Transaction
	#endif

}

char FCD_I2C_Master0_MI2C_Receive_Byte_Transaction(char Device_ID, char AddrH, char AddrL)
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (0 != MX_MIAC_MM_MIAC_BASE)

		unsigned int ModID = ((trisc << 5) + portc) << 9;

		MIAC_CAN_TX[0] = Device_ID;
		MIAC_CAN_TX[1] = AddrH;
		MIAC_CAN_TX[2] = AddrL;

		MIAC_Module_WR(ModID, 391, 3,1,0);
		MIAC_Module_GetAck(ModID + 32, 391, 20);
		return(MIAC_CAN_RX[0]);
	  #endif
	#else
		char RetVal = 0;
		Device_ID = Device_ID << 1;			//Shift Device ID to enable write mode

		FCD_I2C_Master0_MI2C_Start();						//Start transaction
		FCD_I2C_Master0_MI2C_Transmit_Byte(Device_ID);		//Transmit Device Address
		FCD_I2C_Master0_MI2C_Transmit_Byte(AddrH);			//Transmit Internal Address
		FCD_I2C_Master0_MI2C_Transmit_Byte(AddrL);
		FCD_I2C_Master0_MI2C_Restart();						//Restart transaction

		Device_ID = Device_ID | 0x01;		//Change Device ID to read mode
		FCD_I2C_Master0_MI2C_Transmit_Byte(Device_ID);		//Transmit Device Address
		RetVal = FCD_I2C_Master0_MI2C_Receive_Byte(1);		//Read data at address
		FCD_I2C_Master0_MI2C_Stop();						//Stop Transaction

		return RetVal;						//Return data
	#endif
}



//LCDDisplay(0): //Macro implementations


void FCD_LCDDisplay0_RawSend(char in, char mask)
{
	
	#ifndef MX_MIAC_SYSTEM
		unsigned char pt;

		clear_bit(LCD_132012_PORT0, LCD_132012_BIT0);
		clear_bit(LCD_132012_PORT1, LCD_132012_BIT1);
		clear_bit(LCD_132012_PORT2, LCD_132012_BIT2);
		clear_bit(LCD_132012_PORT3, LCD_132012_BIT3);
		clear_bit(LCD_132012_PORT4, LCD_132012_RS);
		clear_bit(LCD_132012_PORT5, LCD_132012_E);
		pt = ((in >> 4) & 0x0f);
		if (pt & 0x01)
		    set_bit(LCD_132012_PORT0, LCD_132012_BIT0);
		if (pt & 0x02)
		    set_bit(LCD_132012_PORT1, LCD_132012_BIT1);
		if (pt & 0x04)
		    set_bit(LCD_132012_PORT2, LCD_132012_BIT2);
		if (pt & 0x08)
		    set_bit(LCD_132012_PORT3, LCD_132012_BIT3);
		if (mask)
		    set_bit(LCD_132012_PORT4, LCD_132012_RS);
		LCD_132012_DELAY;
		set_bit (LCD_132012_PORT5, LCD_132012_E);
		LCD_132012_DELAY;
		clear_bit (LCD_132012_PORT5, LCD_132012_E);
		pt = (in & 0x0f);
		LCD_132012_DELAY;
		clear_bit(LCD_132012_PORT0, LCD_132012_BIT0);
		clear_bit(LCD_132012_PORT1, LCD_132012_BIT1);
		clear_bit(LCD_132012_PORT2, LCD_132012_BIT2);
		clear_bit(LCD_132012_PORT3, LCD_132012_BIT3);
		clear_bit(LCD_132012_PORT4, LCD_132012_RS);
		clear_bit(LCD_132012_PORT5, LCD_132012_E);
		if (pt & 0x01)
		    set_bit(LCD_132012_PORT0, LCD_132012_BIT0);
		if (pt & 0x02)
		    set_bit(LCD_132012_PORT1, LCD_132012_BIT1);
		if (pt & 0x04)
		    set_bit(LCD_132012_PORT2, LCD_132012_BIT2);
		if (pt & 0x08)
		    set_bit(LCD_132012_PORT3, LCD_132012_BIT3);
		if (mask)
		    set_bit(LCD_132012_PORT4, LCD_132012_RS);
		LCD_132012_DELAY;
		set_bit (LCD_132012_PORT5, LCD_132012_E);
		LCD_132012_DELAY;
		clear_bit (LCD_132012_PORT5, LCD_132012_E);
		LCD_132012_DELAY;

	#endif

}

void FCD_LCDDisplay0_Start()
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)

		MIAC_CAN_TX[0] = 4;
		MIAC_CAN_TX[1] = 5;
		MIAC_CAN_TX[2] = 6;
		MIAC_CAN_TX[3] = 7;
		MIAC_CAN_TX[4] = 2;
		MIAC_CAN_TX[5] = 3;

		MIAC_Module_WR(ModIDLCD_132012, 608, 6,1,1);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 608, 20);

		MIAC_CAN_TX[0] = 2;
		MIAC_CAN_TX[1] = 16;
		MIAC_Module_WR(ModIDLCD_132012, 608, 2,0,0);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 608, 255);

	  #endif
	#else

		clear_bit(LCD_132012_TRIS0, LCD_132012_BIT0);
		clear_bit(LCD_132012_TRIS1, LCD_132012_BIT1);
		clear_bit(LCD_132012_TRIS2, LCD_132012_BIT2);
		clear_bit(LCD_132012_TRIS3, LCD_132012_BIT3);
		clear_bit(LCD_132012_TRIS4, LCD_132012_RS);
		clear_bit(LCD_132012_TRIS5, LCD_132012_E);

		Wdt_Delay_Ms(12);

		FCD_LCDDisplay0_RawSend(0x33, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x33, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x32, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x2c, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x06, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x0c, 0);
		Wdt_Delay_Ms(2);

		//clear the display
		FCD_LCDDisplay0_RawSend(0x01, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x02, 0);
		Wdt_Delay_Ms(2);
	#endif

}

void FCD_LCDDisplay0_Clear()
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)

		MIAC_Module_WR(ModIDLCD_132012, 609, 0,1,0);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 609, 200);
	  #endif
	#else
		FCD_LCDDisplay0_RawSend(0x01, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x02, 0);
		Wdt_Delay_Ms(2);
	#endif

}

void FCD_LCDDisplay0_PrintASCII(char Character)
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)



		MIAC_CAN_TX[0] = Character;

		MIAC_Module_WR(ModIDLCD_132012, 610, 1,1,0);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 610, 20);
	  #endif
	#else
		FCD_LCDDisplay0_RawSend(Character, 0x10);
	#endif

}

void FCD_LCDDisplay0_Command(char in)
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)

		MIAC_CAN_TX[0] = in;

		MIAC_Module_WR(ModIDLCD_132012, 611, 1,1,0);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 611, 200);
	  #endif
	#else
		FCD_LCDDisplay0_RawSend(in, 0);
		Wdt_Delay_Ms(2);
	#endif

}

void FCD_LCDDisplay0_Cursor(char x, char y)
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)

		MIAC_CAN_TX[0] = x;
		MIAC_CAN_TX[1] = y;

		MIAC_Module_WR(ModIDLCD_132012, 612, 2,1,0);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 612, 20);
	  #endif

	#else

	  #if (LCD_132012_ROWCNT == 1)
	    y=0x80;
	  #endif

	  #if (LCD_132012_ROWCNT == 2)
		if (y==0)
			y=0x80;
		else
			y=0xc0;
	  #endif

	  #if (LCD_132012_ROWCNT == 4)
		if (y==0)
			y=0x80;
		else if (y==1)
			y=0xc0;

		#if (LCD_132012_COLCNT == 16)
			else if (y==2)
				y=0x90;
			else
				y=0xd0;
		#endif

		#if (LCD_132012_COLCNT == 20)
			else if (y==2)
				y=0x94;
			else
				y=0xd4;
		#endif
	  #endif

		FCD_LCDDisplay0_RawSend(y+x, 0);
		Wdt_Delay_Ms(2);
	#endif

}

void FCD_LCDDisplay0_PrintNumber(short Number)
{
	
		short tmp_int;
		char tmp_byte;
		if (Number < 0)
		{
			FCD_LCDDisplay0_RawSend('-', 0x10);
			Number = 0 - Number;
		}

		tmp_int = Number;
		if (Number >= 10000)
		{
			tmp_byte = tmp_int / 10000;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 10000;
				tmp_byte--;
			}
		}
		if (Number >= 1000)
		{
			tmp_byte = tmp_int / 1000;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);
				
			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 1000;
				tmp_byte--;
			}
		}
		if ((Number >= 100) | (FCV_ZNAK==1))//my
		{
			tmp_byte = tmp_int / 100;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);
				if (FCV_ZNAK==1) FCD_LCDDisplay0_RawSend('.', 0x10);	//my znak
			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 100;
				tmp_byte--;
			}
		}
		if ((Number >= 10) | (FCV_ZNAK==1))	//my
		{
			tmp_byte = tmp_int / 10;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);
				//if (FCV_ZNAK==1) FCD_LCDDisplay0_RawSend('.', 0x10);	//my znak
			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 10;
				tmp_byte--;
			}
		}
		FCD_LCDDisplay0_RawSend('0' + tmp_int, 0x10);

}

void FCD_LCDDisplay0_PrintString(char* String, char MSZ_String)
{
	
		char idx = 0;

	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)

		char msg_count, ch;
		char cmd_start = 1;
		char more_data = 1;

		// Split string into 6-byte packets
		do
		{
			msg_count = 0;
			do
			{
				ch = String[idx];
				if (ch)
				{
					MIAC_CAN_TX[msg_count] = ch;
					idx = idx + 1;
					msg_count = msg_count + 1;
				}
			}
			while (ch && (msg_count < 6) && (idx < MSZ_String));			// check for 2 x End Of String conditions and packet full

			if (idx == MSZ_String)											// end of string
			{
				more_data = 0;
			}else{
				if (String[idx] == 0) more_data = 0;						// next ch = null
			}

			MIAC_Module_WR(ModIDLCD_132012, 614, msg_count,cmd_start,more_data);		// TX data
			MIAC_Module_GetAck(ModIDLCD_132012 + 32, 614, 200);

			cmd_start = 0;
		}
		while (more_data);
	  #endif
	#else
		for (idx=0; idx<MSZ_String; idx++)
		{
			if (String[idx] == 0)
			{
				break;
			}
			FCD_LCDDisplay0_RawSend(String[idx], 0x10);
		}
	#endif

}

void FCD_LCDDisplay0_ScrollDisplay(char Direction, char Num_Positions)
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)

		MIAC_CAN_TX[0] = Direction;
		MIAC_CAN_TX[1] = Num_Positions;

		MIAC_Module_WR(ModIDLCD_132012, 615, 2,1,0);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 615, 20);
	  #endif
	#else

		char cmd = 0;
		char count;

		//Choose the direction
		switch (Direction)
		{
			case 0:
			case 'l':
			case 'L':

				cmd = 0x18;
				break;

			case 1:
			case 'r':
			case 'R':

				cmd = 0x1C;
				break;

			default:
				break;
		}

		//If direction accepted then scroll the specified amount
		if (cmd)
		{
			for (count = 0; count < Num_Positions; count++)
				FCD_LCDDisplay0_Command(cmd);
		}
	#endif

}

void FCD_LCDDisplay0_ClearLine(char Line)
{
	
	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)

		MIAC_CAN_TX[0] = Line;

		MIAC_Module_WR(ModIDLCD_132012, 616, 1,1,0);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 616, 200);
	  #endif
	#else
		char count;
		char rowcount;

		//Define number of columns per line
		#if (LCD_132012_ROWCNT == 1)
			rowcount=80;
		#endif

		#if (LCD_132012_ROWCNT == 2)
			rowcount=40;
		#endif

		#if (LCD_132012_ROWCNT == 4)
			#if (LCD_132012_COLCNT == 16)
				rowcount=16;
			#endif
			#if (LCD_132012_COLCNT == 20)
				rowcount=20;
			#endif
		#endif

		//Start at beginning of the line
		FCD_LCDDisplay0_Cursor (0, Line);

		//Send out spaces to clear line
		for (count = 0; count < rowcount; count++)
			FCD_LCDDisplay0_RawSend(' ', 0x10);

		//Move back to the beginning of the line.
		FCD_LCDDisplay0_Cursor (0, Line);
	#endif

}

void FCD_LCDDisplay0_RAM_Write(char nIdx, char d0, char d1, char d2, char d3, char d4, char d5, char d6, char d7)
{
	   //set CGRAM address

	#ifdef MX_MIAC_SYSTEM
	  #if (portd != MX_MIAC_MM_MIAC_BASE)

		MIAC_CAN_TX[0] = nIdx;
		MIAC_CAN_TX[1] = d0;
		MIAC_CAN_TX[2] = d1;
		MIAC_CAN_TX[3] = d2;
		MIAC_CAN_TX[4] = d3;
		MIAC_CAN_TX[5] = d4;

		MIAC_Module_WR(ModIDLCD_132012, 617, 6,1,1);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 617, 20);

		MIAC_CAN_TX[0] = d5;
		MIAC_CAN_TX[1] = d6;
		MIAC_CAN_TX[2] = d7;

		MIAC_Module_WR(ModIDLCD_132012, 617, 3,0,0);
		MIAC_Module_GetAck(ModIDLCD_132012 + 32, 617, 200);

	  #endif
	#else

	   FCD_LCDDisplay0_RawSend(64 + (nIdx << 3), 0);
	   delay_ms(2);

	   //write CGRAM data
	   FCD_LCDDisplay0_RawSend(d0, 0x10);
	   FCD_LCDDisplay0_RawSend(d1, 0x10);
	   FCD_LCDDisplay0_RawSend(d2, 0x10);
	   FCD_LCDDisplay0_RawSend(d3, 0x10);
	   FCD_LCDDisplay0_RawSend(d4, 0x10);
	   FCD_LCDDisplay0_RawSend(d5, 0x10);
	   FCD_LCDDisplay0_RawSend(d6, 0x10);
	   FCD_LCDDisplay0_RawSend(d7, 0x10);

	   //Clear the display
	   FCD_LCDDisplay0_RawSend(0x01, 0);
	   delay_ms(2);
	   FCD_LCDDisplay0_RawSend(0x02, 0);
	   delay_ms(2);
	#endif

}

//Macro implementations

void FCM_LCD()
{
	
	//??????
	//Call Component Macro: LCDDisplay(0)::Cursor(0, 0)
	FCD_LCDDisplay0_Cursor(0, 0);


	//??????????? ?
	//Call Component Macro: LCDDisplay(0)::PrintNumber(H)
	FCD_LCDDisplay0_PrintNumber(FCV_H);


	//
	//Call Component Macro: LCDDisplay(0)::PrintASCII(" H ")
	FCD_LCDDisplay0_PrintASCII(' ');
	FCD_LCDDisplay0_PrintASCII('H');
	FCD_LCDDisplay0_PrintASCII(' ');


	//??????
	//Call Component Macro: LCDDisplay(0)::Cursor(9, 0)
	FCD_LCDDisplay0_Cursor(9, 0);


	//??????????? ?
	//Call Component Macro: LCDDisplay(0)::PrintString(H_str)
	FCD_LCDDisplay0_PrintString(FCV_H_STR,FCSZ_H_STR);


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintASCII('%')
	FCD_LCDDisplay0_PrintASCII('%');


	//??????
	//Call Component Macro: LCDDisplay(0)::Cursor(0, 1)
	FCD_LCDDisplay0_Cursor(0, 1);


	//
	//Calculation:
	//  znak = 1
	FCV_ZNAK = 1;
	

	//??????????? ?
	//Call Component Macro: LCDDisplay(0)::PrintNumber(T)
	FCD_LCDDisplay0_PrintNumber(FCV_T);


	//
	//Calculation:
	//  znak = 0
	FCV_ZNAK = 0;
	

	//
	//Call Component Macro: LCDDisplay(0)::PrintASCII(" T ")
	FCD_LCDDisplay0_PrintASCII(' ');
	FCD_LCDDisplay0_PrintASCII('T');
	FCD_LCDDisplay0_PrintASCII(' ');


	//??????
	//Call Component Macro: LCDDisplay(0)::Cursor(9, 1)
	FCD_LCDDisplay0_Cursor(9, 1);


	//??????????? ?
	//Call Component Macro: LCDDisplay(0)::PrintString(T_str)
	FCD_LCDDisplay0_PrintString(FCV_T_STR,FCSZ_T_STR);


}

void FCM_TEMPER()
{
	//???????? ????????? ???????????
	
	//Comment:
	//?????? ????????? ? ????????? ??????


	//Calculation
	//Calculation:
	//  t_C = int2float(T)
	//  t_C = fmul(t_C,0.01)
	//  t_C = fsub(t_C,40.0)
	FCV_T_C = float32_from_int32(FCV_T);
	FCV_T_C = float32_mul(FCV_T_C,0.01);
	FCV_T_C = float32_sub(FCV_T_C,40.0);
	

	//String Manipulation
	//String Manipulation:
	//  T_str = FloatToString$(t_C)
	FCI_FLOAT_TO_STRING(FCV_T_C,6,FCV_T_STR,FCSZ_T_STR);
	

	//Comment:
	//?????? ???????? ??? ????????? ?????


	//Calculation
	//Calculation:
	//  T = T-4000      //4072 - ???? ??????? ? ????
	FCV_T = FCV_T-4000;      //4072 - ???? ??????? ? ????
	

	//Comment:
	//??? ????? ??????? ????????? ??????????? ??????????
	//Non-Linearity_Compensation_Humidity_Sensors_E.pdf


}

void FCM_HUMIDITY()
{
	//???????? ????????? ?????????
	
	//Comment:
	//?????? ????????? ? ????????? ??????


	//Comment:
	//RH = int2float(H)
	//temp = fmul(RH,0.0396) //0.0405
	//RH = fmul(RH,RH)
	//RH = fmul(RH,-0.0000028)
	//RH = fadd((fadd(RH,temp)),-4.0)
	////RH = fadd(RH,-4.0)


	//Calculation
	//Calculation:
	//  RH = int2float(H)
	//  temp = fmul(RH,0.0406) //0.0405
	//  RH = fmul(RH,RH)
	//  RH = fmul(RH,-0.0000028)
	//  RH = fadd((fadd(RH,temp)),-7.3)
	//  //RH = fadd(RH,-4.0)
	FCV_RH = float32_from_int32(FCV_H);
	FCV_TEMP = float32_mul(FCV_RH,0.0406); //0.0405
	FCV_RH = float32_mul(FCV_RH,FCV_RH);
	FCV_RH = float32_mul(FCV_RH,-0.0000028);
	FCV_RH = float32_add((float32_add(FCV_RH,FCV_TEMP)),-7.3);
	//RH = fadd(RH,-4.0)
	

	//String Manipulation
	//String Manipulation:
	//  H_str = FloatToString$(RH)
	FCI_FLOAT_TO_STRING(FCV_RH,6,FCV_H_STR,FCSZ_H_STR);
	

	//Comment:
	//??? ????? ??????? ????????? ??????????? ??????????
	//Non-Linearity_Compensation_Humidity_Sensors_E.pdf


}

void FCM_READ_BUS()
{
	
	//C Code
	//C Code:
	static char in;
	static char counter;
	in=1;
	counter=0;
	while (in ==1)
		{
			in = portc.4;
			delay_ms(4);
			counter++;
			if (counter == 0x7F)		// Security: if the conversion is not completed
				break;				// after > 0.5 sec -> break.
		}



}

void FCM_PULS_A()
{
	
	//Comment:
	//_/-\_/-\_   _SCL
	//--\___/--   _SDA


	//
	//Call Component Macro: I2C_Master(0)::MI2C_Restart
	FCD_I2C_Master0_MI2C_Restart();


	//Comment:
	//?????? ???? ???????, ????? ? ???? ? ????????.
	//???????????????? ???? ??????? - ???????? 10 ??


	//
	//Call Component Macro: I2C_Master(0)::MI2C_Stop
	FCD_I2C_Master0_MI2C_Stop();


}

void main()
{
	//????? ??????? SHT10
	//??????? ??????
	//?????????? ???????
	
	//Initialisation
	adcon1 = 0x07;


	//Interrupt initialisation code
	option_reg = 0xC0;


	//I2C
	//Call Component Macro: LCDDisplay(0)::Start
	FCD_LCDDisplay0_Start();


	//Call Component Macro
	//Call Component Macro: I2C_Master(0)::MI2C_Init
	FCD_I2C_Master0_MI2C_Init();


	//Delay
	//Delay: 10 ms
	delay_ms(10);


	//Comment:
	//?????


	//Call Macro
	//Call Macro: PULS_A
	FCM_PULS_A();


	//C???? ???????
	//Call Component Macro: I2C_Master(0)::MI2C_Transmit_Byte(0b00011110)
	FCD_I2C_Master0_MI2C_Transmit_Byte(0b00011110);


	//Delay
	//Delay: 1 ms
	delay_ms(1);


	//Loop
	//Loop: While 1
	while (1)
	{
		//Comment:
		//?????


		//?????
		//Call Macro: PULS_A
		FCM_PULS_A();


		//??????? ??? ???????
		//Call Component Macro: I2C_Master(0)::MI2C_Transmit_Byte(0b00000101)
		FCD_I2C_Master0_MI2C_Transmit_Byte(0b00000101);


		//Call Macro
		//Call Macro: READ_BUS
		FCM_READ_BUS();


		//?????? ???????? ?????
		//Call Component Macro: MSB_H=I2C_Master(0)::MI2C_Receive_Byte(0)
		FCV_MSB_H = FCD_I2C_Master0_MI2C_Receive_Byte(0);


		//?????? ???????? ?????
		//Call Component Macro: LSB_H=I2C_Master(0)::MI2C_Receive_Byte(1)
		FCV_LSB_H = FCD_I2C_Master0_MI2C_Receive_Byte(1);


		//Delay
		//Delay: 10 ms
		delay_ms(10);


		//Comment:
		//?????


		//Call Macro
		//Call Macro: PULS_A
		FCM_PULS_A();


		//??????? ??? ???????
		//Call Component Macro: I2C_Master(0)::MI2C_Transmit_Byte(0b00000011)
		FCD_I2C_Master0_MI2C_Transmit_Byte(0b00000011);


		//Call Macro
		//Call Macro: READ_BUS
		FCM_READ_BUS();


		//?????? ???????? ?????
		//Call Component Macro: MSB_T=I2C_Master(0)::MI2C_Receive_Byte(0)
		FCV_MSB_T = FCD_I2C_Master0_MI2C_Receive_Byte(0);


		//?????? ???????? ?????
		//Call Component Macro: LSB_T=I2C_Master(0)::MI2C_Receive_Byte(1)
		FCV_LSB_T = FCD_I2C_Master0_MI2C_Receive_Byte(1);


		//Delay
		//Delay: 100 ms
		delay_ms(100);


		//Comment:
		//???????????? ?????? ?????????? ?? ???????


		//Calculation
		//Calculation:
		//  T = (MSB_T<<8) | LSB_T
		//  H = (MSB_H<<8) | LSB_H
		FCV_T = (FCV_MSB_T<<8) | FCV_LSB_T;
		FCV_H = (FCV_MSB_H<<8) | FCV_LSB_H;
		

		//Comment:
		//const float C1=-4.0;              // for 12 Bit    
		//const float C2=+0.0405;           // for 12 Bit    
		//const float C3=-0.0000028;        // for 12 Bit    
		//const float T1=+0.01;             // for 14 Bit @ 5V    
		//const float T2=+0.00008;          // for 14 Bit @ 5V        


		//Comment:
		//t_C=t*0.01 - 40.07;               //calc. temperature from ticks to [C]    
		//rh_lin=C3*rh*rh + C2*rh + C1;     //calc. humidity from ticks to [%RH]    
		//rh_true=(t_C-25)*(T1+T2*rh)+rh_lin-3.8;   //calc. temperature compensated humidity [%RH]    


		//???????? T
		//Call Macro: TEMPER
		FCM_TEMPER();


		//???????? H
		//Call Macro: HUMIDITY
		FCM_HUMIDITY();


		//LCD
		//Call Macro: LCD
		FCM_LCD();


	}


	mainendloop: goto mainendloop;
}

void MX_INTERRUPT_MACRO(void)
{
}



